/* server.cmdline.h */

/* File autogenerated by gengetopt version 2.17rc  */

#ifndef SERVER_CMDLINE_H
#define SERVER_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE "para_server"
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION "(paraslash 0.2.12, oriented abstraction)\nCopyright (c) 1997-2006 by Andre Noll\nThis is free software with ABSOLUTELY NO WARRANTY. See COPYING for details."
#endif

struct gengetopt_args_info
{
  const char *help_help; /* Print help and exit help description.  */
  const char *version_help; /* Print version and exit help description.  */
  int loglevel_arg;	/* set loglevel (0-6) (default='4').  */
  char * loglevel_orig;	/* set loglevel (0-6) original value given at command line.  */
  const char *loglevel_help; /* set loglevel (0-6) help description.  */
  int port_arg;	/* listening port (default='2990').  */
  char * port_orig;	/* listening port original value given at command line.  */
  const char *port_help; /* listening port help description.  */
  int daemon_flag;	/* run as background daemon (default=off).  */
  const char *daemon_help; /* run as background daemon help description.  */
  char * user_arg;	/* run as user 'name'. para_server does not
  need any special privileges. If started as
  root (EUID == 0) this option must be given at
  the command line (not in the configuration
  file) so that para_server can drop the root
  privileges right after parsing the command
  line options, but before parsing the
  configuration file. In this case,
  real/effective/saved UID are all set to the
  UID of 'username'. As the configuration file
  is read afterwards, those options that have a
  default value depending on the UID (e.g. the
  directory for the configuration file) are
  computed by using the uid of 'username'.
  This option has no effect if para_server is
  started as a non-root user (i.e.  EUID != 0).  */
  char * user_orig;	/* run as user 'name'. para_server does not
  need any special privileges. If started as
  root (EUID == 0) this option must be given at
  the command line (not in the configuration
  file) so that para_server can drop the root
  privileges right after parsing the command
  line options, but before parsing the
  configuration file. In this case,
  real/effective/saved UID are all set to the
  UID of 'username'. As the configuration file
  is read afterwards, those options that have a
  default value depending on the UID (e.g. the
  directory for the configuration file) are
  computed by using the uid of 'username'.
  This option has no effect if para_server is
  started as a non-root user (i.e.  EUID != 0) original value given at command line.  */
  const char *user_help; /* run as user 'name'. para_server does not
  need any special privileges. If started as
  root (EUID == 0) this option must be given at
  the command line (not in the configuration
  file) so that para_server can drop the root
  privileges right after parsing the command
  line options, but before parsing the
  configuration file. In this case,
  real/effective/saved UID are all set to the
  UID of 'username'. As the configuration file
  is read afterwards, those options that have a
  default value depending on the UID (e.g. the
  directory for the configuration file) are
  computed by using the uid of 'username'.
  This option has no effect if para_server is
  started as a non-root user (i.e.  EUID != 0) help description.  */
  char * group_arg;	/* set group id to according to 'group'. This
  option is silently ignored if EUID != 0.
  Otherwise, real/effective GID and the saved
  set-group ID are all set to the GID given by
  'group'. Must not be given in the config file..  */
  char * group_orig;	/* set group id to according to 'group'. This
  option is silently ignored if EUID != 0.
  Otherwise, real/effective GID and the saved
  set-group ID are all set to the GID given by
  'group'. Must not be given in the config file. original value given at command line.  */
  const char *group_help; /* set group id to according to 'group'. This
  option is silently ignored if EUID != 0.
  Otherwise, real/effective GID and the saved
  set-group ID are all set to the GID given by
  'group'. Must not be given in the config file. help description.  */
  char * logfile_arg;	/* (default=stdout/stderr).  */
  char * logfile_orig;	/* (default=stdout/stderr) original value given at command line.  */
  const char *logfile_help; /* (default=stdout/stderr) help description.  */
  char * config_file_arg;	/* (default='~/.paraslash/server.conf'.  */
  char * config_file_orig;	/* (default='~/.paraslash/server.conf' original value given at command line.  */
  const char *config_file_help; /* (default='~/.paraslash/server.conf' help description.  */
  char * user_list_arg;	/* (default='~/.paraslash/server.users').  */
  char * user_list_orig;	/* (default='~/.paraslash/server.users') original value given at command line.  */
  const char *user_list_help; /* (default='~/.paraslash/server.users') help description.  */
  int autoplay_flag;	/* start playing on startup (default=off).  */
  const char *autoplay_help; /* start playing on startup help description.  */
  int announce_time_arg;	/* Delay betweeen announcing the stream and sending data (default='300').  */
  char * announce_time_orig;	/* Delay betweeen announcing the stream and sending data original value given at command line.  */
  const char *announce_time_help; /* Delay betweeen announcing the stream and sending data help description.  */
  char * selector_arg;	/* (default=random).  */
  char * selector_orig;	/* (default=random) original value given at command line.  */
  const char *selector_help; /* (default=random) help description.  */
  char * mysql_host_arg;	/* mysql server (default='localhost').  */
  char * mysql_host_orig;	/* mysql server original value given at command line.  */
  const char *mysql_host_help; /* mysql server help description.  */
  int mysql_port_arg;	/* where mysql is listening (default='3306').  */
  char * mysql_port_orig;	/* where mysql is listening original value given at command line.  */
  const char *mysql_port_help; /* where mysql is listening help description.  */
  char * mysql_user_arg;	/* default value: username from /etc/passwd.  */
  char * mysql_user_orig;	/* default value: username from /etc/passwd original value given at command line.  */
  const char *mysql_user_help; /* default value: username from /etc/passwd help description.  */
  char * mysql_passwd_arg;	/* (required).  */
  char * mysql_passwd_orig;	/* (required) original value given at command line.  */
  const char *mysql_passwd_help; /* (required) help description.  */
  char * mysql_database_arg;	/* name of mysql database (default='paraslash').  */
  char * mysql_database_orig;	/* name of mysql database original value given at command line.  */
  const char *mysql_database_help; /* name of mysql database help description.  */
  char * mysql_audio_file_dir_arg;	/* dir to search for audio files (required).  */
  char * mysql_audio_file_dir_orig;	/* dir to search for audio files (required) original value given at command line.  */
  const char *mysql_audio_file_dir_help; /* dir to search for audio files (required) help description.  */
  char * mysql_default_score_arg;	/* scoring rule to use if stream definition
  does not contain explicit score definition (default='(LASTPLAYED() / 1440 - 1000 / (LASTPLAYED() + 1) - sqrt(NUMPLAYED()))').  */
  char * mysql_default_score_orig;	/* scoring rule to use if stream definition
  does not contain explicit score definition original value given at command line.  */
  const char *mysql_default_score_help; /* scoring rule to use if stream definition
  does not contain explicit score definition help description.  */
  char * random_dir_arg;	/* dir to search for audio files (default='/home/music').  */
  char * random_dir_orig;	/* dir to search for audio files original value given at command line.  */
  const char *random_dir_help; /* dir to search for audio files help description.  */
  int http_port_arg;	/* tcp port for http streaming (default='8000').  */
  char * http_port_orig;	/* tcp port for http streaming original value given at command line.  */
  const char *http_port_help; /* tcp port for http streaming help description.  */
  int http_default_deny_flag;	/* deny connections from hosts which are not
  explicitly allowed (default=off).  */
  const char *http_default_deny_help; /* deny connections from hosts which are not
  explicitly allowed help description.  */
  char ** http_access_arg;	/* Add given host/network to access control
  list (whitelist if http_default_deny was
  given, blacklist otherwise) before opening
  the tcp port. This option can be given
  multiple times. Example: '192.168.0.0/24'
  whitelists/blacklists the 256 hosts
  192.168.0.x.  */
  char ** http_access_orig;	/* Add given host/network to access control
  list (whitelist if http_default_deny was
  given, blacklist otherwise) before opening
  the tcp port. This option can be given
  multiple times. Example: '192.168.0.0/24'
  whitelists/blacklists the 256 hosts
  192.168.0.x original value given at command line.  */
  int http_access_min; /* Add given host/network to access control
  list (whitelist if http_default_deny was
  given, blacklist otherwise) before opening
  the tcp port. This option can be given
  multiple times. Example: '192.168.0.0/24'
  whitelists/blacklists the 256 hosts
  192.168.0.x's minimum occurreces */
  int http_access_max; /* Add given host/network to access control
  list (whitelist if http_default_deny was
  given, blacklist otherwise) before opening
  the tcp port. This option can be given
  multiple times. Example: '192.168.0.0/24'
  whitelists/blacklists the 256 hosts
  192.168.0.x's maximum occurreces */
  const char *http_access_help; /* Add given host/network to access control
  list (whitelist if http_default_deny was
  given, blacklist otherwise) before opening
  the tcp port. This option can be given
  multiple times. Example: '192.168.0.0/24'
  whitelists/blacklists the 256 hosts
  192.168.0.x help description.  */
  int http_no_autostart_flag;	/* do not open tcp port on server startup (default=off).  */
  const char *http_no_autostart_help; /* do not open tcp port on server startup help description.  */
  int http_max_clients_arg;	/* maximal simultaneous connections,
  non-positive value means unlimited (default='-1').  */
  char * http_max_clients_orig;	/* maximal simultaneous connections,
  non-positive value means unlimited original value given at command line.  */
  const char *http_max_clients_help; /* maximal simultaneous connections,
  non-positive value means unlimited help description.  */
  int dccp_port_arg;	/* port for dccp streaming (default='5001').  */
  char * dccp_port_orig;	/* port for dccp streaming original value given at command line.  */
  const char *dccp_port_help; /* port for dccp streaming help description.  */
  char ** ortp_target_arg;	/* Add given host/port to the list of targets.
  This option can be given multiple times.
  Example: '224.0.1.38:1500' instructs the ortp
  sender to send to udp port 1500 on host
  224.0.1.38 (unassigned ip in the Local
  Network Control Block 224.0.0/24). This is
  useful for LAN-streaming..  */
  char ** ortp_target_orig;	/* Add given host/port to the list of targets.
  This option can be given multiple times.
  Example: '224.0.1.38:1500' instructs the ortp
  sender to send to udp port 1500 on host
  224.0.1.38 (unassigned ip in the Local
  Network Control Block 224.0.0/24). This is
  useful for LAN-streaming. original value given at command line.  */
  int ortp_target_min; /* Add given host/port to the list of targets.
  This option can be given multiple times.
  Example: '224.0.1.38:1500' instructs the ortp
  sender to send to udp port 1500 on host
  224.0.1.38 (unassigned ip in the Local
  Network Control Block 224.0.0/24). This is
  useful for LAN-streaming.'s minimum occurreces */
  int ortp_target_max; /* Add given host/port to the list of targets.
  This option can be given multiple times.
  Example: '224.0.1.38:1500' instructs the ortp
  sender to send to udp port 1500 on host
  224.0.1.38 (unassigned ip in the Local
  Network Control Block 224.0.0/24). This is
  useful for LAN-streaming.'s maximum occurreces */
  const char *ortp_target_help; /* Add given host/port to the list of targets.
  This option can be given multiple times.
  Example: '224.0.1.38:1500' instructs the ortp
  sender to send to udp port 1500 on host
  224.0.1.38 (unassigned ip in the Local
  Network Control Block 224.0.0/24). This is
  useful for LAN-streaming. help description.  */
  int ortp_no_autostart_flag;	/* do not start to send automatically (default=off).  */
  const char *ortp_no_autostart_help; /* do not start to send automatically help description.  */
  int ortp_default_port_arg;	/* default udp port if not specified (default='1500').  */
  char * ortp_default_port_orig;	/* default udp port if not specified original value given at command line.  */
  const char *ortp_default_port_help; /* default udp port if not specified help description.  */
  int ortp_header_interval_arg;	/* time between extra header sends (default='2000').  */
  char * ortp_header_interval_orig;	/* time between extra header sends original value given at command line.  */
  const char *ortp_header_interval_help; /* time between extra header sends help description.  */
  int ortp_jitter_compensation_arg;	/* non-zero values enable ortp's adaptive
  jitter compensation (default='400').  */
  char * ortp_jitter_compensation_orig;	/* non-zero values enable ortp's adaptive
  jitter compensation original value given at command line.  */
  const char *ortp_jitter_compensation_help; /* non-zero values enable ortp's adaptive
  jitter compensation help description.  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int loglevel_given ;	/* Whether loglevel was given.  */
  int port_given ;	/* Whether port was given.  */
  int daemon_given ;	/* Whether daemon was given.  */
  int user_given ;	/* Whether user was given.  */
  int group_given ;	/* Whether group was given.  */
  int logfile_given ;	/* Whether logfile was given.  */
  int config_file_given ;	/* Whether config_file was given.  */
  int user_list_given ;	/* Whether user_list was given.  */
  int autoplay_given ;	/* Whether autoplay was given.  */
  int announce_time_given ;	/* Whether announce_time was given.  */
  int selector_given ;	/* Whether selector was given.  */
  int mysql_host_given ;	/* Whether mysql_host was given.  */
  int mysql_port_given ;	/* Whether mysql_port was given.  */
  int mysql_user_given ;	/* Whether mysql_user was given.  */
  int mysql_passwd_given ;	/* Whether mysql_passwd was given.  */
  int mysql_database_given ;	/* Whether mysql_database was given.  */
  int mysql_audio_file_dir_given ;	/* Whether mysql_audio_file_dir was given.  */
  int mysql_default_score_given ;	/* Whether mysql_default_score was given.  */
  int random_dir_given ;	/* Whether random_dir was given.  */
  int http_port_given ;	/* Whether http_port was given.  */
  int http_default_deny_given ;	/* Whether http_default_deny was given.  */
  unsigned int http_access_given ;	/* Whether http_access was given.  */
  int http_no_autostart_given ;	/* Whether http_no_autostart was given.  */
  int http_max_clients_given ;	/* Whether http_max_clients was given.  */
  int dccp_port_given ;	/* Whether dccp_port was given.  */
  unsigned int ortp_target_given ;	/* Whether ortp_target was given.  */
  int ortp_no_autostart_given ;	/* Whether ortp_no_autostart was given.  */
  int ortp_default_port_given ;	/* Whether ortp_default_port was given.  */
  int ortp_header_interval_given ;	/* Whether ortp_header_interval was given.  */
  int ortp_jitter_compensation_given ;	/* Whether ortp_jitter_compensation was given.  */

} ;

extern const char *gengetopt_args_info_purpose;
extern const char *gengetopt_args_info_usage;
extern const char *gengetopt_args_info_help[];

int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

void cmdline_parser_init (struct gengetopt_args_info *args_info);
void cmdline_parser_free (struct gengetopt_args_info *args_info);

int cmdline_parser_configfile (char * const filename,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* SERVER_CMDLINE_H */
