/* write.cmdline.h */

/* File autogenerated by gengetopt version 2.17rc  */

#ifndef WRITE_CMDLINE_H
#define WRITE_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE "para_write"
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION "(paraslash 0.2.12, oriented abstraction)\nCopyright (c) 1997-2006 by Andre Noll\nThis is free software with ABSOLUTELY NO WARRANTY. See COPYING for details."
#endif

struct gengetopt_args_info
{
  const char *help_help; /* Print help and exit help description.  */
  const char *version_help; /* Print version and exit help description.  */
  int list_writers_flag;	/* print available writers and exit (default=off).  */
  const char *list_writers_help; /* print available writers and exit help description.  */
  int loglevel_arg;	/* set loglevel (0-6) (default='4').  */
  char * loglevel_orig;	/* set loglevel (0-6) original value given at command line.  */
  const char *loglevel_help; /* set loglevel (0-6) help description.  */
  int bufsize_arg;	/* input buffer size (default='64').  */
  char * bufsize_orig;	/* input buffer size original value given at command line.  */
  const char *bufsize_help; /* input buffer size help description.  */
  int prebuffer_arg;	/* delay playback until buffer is filled (default='100').  */
  char * prebuffer_orig;	/* delay playback until buffer is filled original value given at command line.  */
  const char *prebuffer_help; /* delay playback until buffer is filled help description.  */
  char ** writer_arg;	/* select stream writer
  may be give multiple times. The same writer
  may be specified more than once (default='alsa (file if alsa is unsupported)').  */
  char ** writer_orig;	/* select stream writer
  may be give multiple times. The same writer
  may be specified more than once original value given at command line.  */
  int writer_min; /* select stream writer
  may be give multiple times. The same writer
  may be specified more than once's minimum occurreces */
  int writer_max; /* select stream writer
  may be give multiple times. The same writer
  may be specified more than once's maximum occurreces */
  const char *writer_help; /* select stream writer
  may be give multiple times. The same writer
  may be specified more than once help description.  */
  char * start_time_arg;	/* start playback at given time which must be
  in a:b format where a denotes seconds and b
  denotes microseconds since the epoch.  */
  char * start_time_orig;	/* start playback at given time which must be
  in a:b format where a denotes seconds and b
  denotes microseconds since the epoch original value given at command line.  */
  const char *start_time_help; /* start playback at given time which must be
  in a:b format where a denotes seconds and b
  denotes microseconds since the epoch help description.  */
  char * device_arg;	/* set PCM device (default='plughw:0,0').  */
  char * device_orig;	/* set PCM device original value given at command line.  */
  const char *device_help; /* set PCM device help description.  */
  int channels_arg;	/* number of channels (only neccessary for raw
  audio) (default='2').  */
  char * channels_orig;	/* number of channels (only neccessary for raw
  audio) original value given at command line.  */
  const char *channels_help; /* number of channels (only neccessary for raw
  audio) help description.  */
  int sample_rate_arg;	/* force given sample rate (only neccessary for
  raw audio) (default='44100').  */
  char * sample_rate_orig;	/* force given sample rate (only neccessary for
  raw audio) original value given at command line.  */
  const char *sample_rate_help; /* force given sample rate (only neccessary for
  raw audio) help description.  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int list_writers_given ;	/* Whether list_writers was given.  */
  int loglevel_given ;	/* Whether loglevel was given.  */
  int bufsize_given ;	/* Whether bufsize was given.  */
  int prebuffer_given ;	/* Whether prebuffer was given.  */
  unsigned int writer_given ;	/* Whether writer was given.  */
  int start_time_given ;	/* Whether start_time was given.  */
  int device_given ;	/* Whether device was given.  */
  int channels_given ;	/* Whether channels was given.  */
  int sample_rate_given ;	/* Whether sample_rate was given.  */

} ;

extern const char *gengetopt_args_info_purpose;
extern const char *gengetopt_args_info_usage;
extern const char *gengetopt_args_info_help[];

int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

void cmdline_parser_init (struct gengetopt_args_info *args_info);
void cmdline_parser_free (struct gengetopt_args_info *args_info);

int cmdline_parser_configfile (char * const filename,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* WRITE_CMDLINE_H */
